=== g2o/EXTERNAL/CMakeLists.txt ===
if (G2O_HAVE_OPENGL)
  add_subdirectory(freeglut)
endif()
if(G2O_USE_VENDORED_CERES)
  add_subdirectory(ceres)
endif()
