=== g2o/EXTERNAL/ceres/CMakeLists.txt ===
add_library(g2o_ceres_ad INTERFACE)

install(TARGETS g2o_ceres_ad
  EXPORT ${G2O_TARGETS_EXPORT_NAME}
  RUNTIME DESTINATION ${RUNTIME_DESTINATION}
  LIBRARY DESTINATION ${LIBRARY_DESTINATION}
  ARCHIVE DESTINATION ${ARCHIVE_DESTINATION}
  INCLUDES DESTINATION ${INCLUDES_DESTINATION}
)

file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h" "${CMAKE_CURRENT_SOURCE_DIR}/*.hpp")
install(FILES ${headers} DESTINATION ${INCLUDES_INSTALL_DIR}/EXTERNAL/ceres)
install(FILES LICENSE DESTINATION ${INCLUDES_INSTALL_DIR}/EXTERNAL/ceres)
