=== debian/changelog ===
ros-humble-libg2o (2020.5.29-4bookworm) bookworm; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Wed, 31 Jul 2024 08:02:37 -0000
